use eframe::{
    egui::{CentralPanel, Context, Label, ScrollArea, WidgetText},
    App, Frame, NativeOptions,
};

#[derive(Default)]
struct ScrollTestApp {}

impl App for ScrollTestApp {
    fn update(&mut self, ctx: &Context, _frame: &mut Frame) {
        CentralPanel::default().show(ctx, |ui| {
            ScrollArea::both().show(ui, |ui| {
                ui.horizontal(|ui| {
                    ui.add_sized([1000.0, 0.0], Label::new(WidgetText::default()));
                    ScrollArea::both().show(ui, |ui| {
                        ui.label("Right ScrollArea");
                    });
                });
                ui.add_sized([0.0, 1000.0], Label::new(WidgetText::default()));
                ScrollArea::both().show(ui, |ui| {
                    ui.label("Bottom ScrollArea");
                    ui.label("Bottom ScrollArea");
                    ui.label("Bottom ScrollArea");
                    ui.label("Bottom ScrollArea");
                    ui.label("Bottom ScrollArea");
                    ui.label("Bottom ScrollArea");
                });
            });
        });
    }
}

fn main() {
    eframe::run_native(
        "Scroll Test",
        NativeOptions::default(),
        Box::new(|_| Box::new(ScrollTestApp::default())),
    )
    .expect("Should always be Ok");
}
